n, m = map(int, input().split())
arr_a = tuple(int(num) for num in input().split())
min_size = min(n, m)


def is_pal(arr):
	for i in range(len(arr) // 2):
		if arr[i] != arr[-i - 1]:
			return False

	return True


max_pal = 0
run = True

for start in range(n - 1):
	for num in range(min(min_size, n - start), 1, -1):
		if num < max_pal:
			run = False
			break
		if is_pal(arr_a[start:start + num]):
			max_pal = num
			break
	if not run:
		break

print(min(max_pal, min_size))