from fractions import Fraction
from math import gcd

fraction_cnt, index_cnt = map(int, input().split())

numerators = tuple(int(num) for num in input().split())
denominators = tuple(int(num) for num in input().split())

fractions = []
for i in numerators:
	for j in denominators:
		fractions.append(Fraction(i, j))

mult = 1
denoms = []
for d in fractions:
	mult *= d.denominator
	denoms.append(d.denominator)
coef = mult // gcd(*denoms)

tup_frac = []

for frac in fractions:
	tup_frac.append((frac.numerator * coef // frac.denominator, frac.denominator))

tup_frac.sort(key=lambda x: x[0])

indexs = map(int, input().split())
for i in indexs:
	denominator = tup_frac[i-1][1]
	numerator = tup_frac[i-1][0] * denominator // coef
	print(numerator, denominator)